/* A Bison parser, made from /home/ellson/graphviz/agraph/grammar.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	T_graph	257
# define	T_node	258
# define	T_edge	259
# define	T_digraph	260
# define	T_subgraph	261
# define	T_strict	262
# define	T_edgeop	263
# define	T_list	264
# define	T_attr	265
# define	T_atom	266
# define	T_qatom	267

#line 1 "/home/ellson/graphviz/agraph/grammar.y"

/*
    This software may only be used by you under license from AT&T Corp.
    ("AT&T").  A copy of AT&T's Source Code Agreement is available at
    AT&T's Internet website having the URL:
    <http://www.research.att.com/sw/tools/graphviz/license/source.html>
    If you received this software without first entering into a license
    with AT&T, you have an infringing copy of this software and cannot use
    it without violating AT&T's intellectual property rights.
*/
#pragma prototyped

#include <stdio.h>  /* SAFE */
#include <aghdr.h>	/* SAFE */

#ifdef _WIN32
#define gettxt(a,b)	(b)
#endif

static char Key[] = "key";

typedef union s {					/* possible items in generic list */
		Agnode_t		*n;
		Agraph_t		*subg;
		Agedge_t		*e;
		Agsym_t			*asym;	/* bound attribute */
		char			*name;	/* unbound attribute */
		struct item_s	*list;	/* list-of-lists (for edgestmt) */
} val_t;

typedef struct item_s {		/* generic list */
	int				tag;	/* T_node, T_subgraph, T_edge, T_attr */
	val_t			u;		/* primary element */
	char			*str;	/* secondary value - port or attr value */
	struct item_s	*next;
} item;

typedef struct list_s {		/* maintain head and tail ptrs for fast append */
	item			*first;
	item			*last;
} list_t;

/* functions */
static void appendnode(char *name, char *port);
static void attrstmt(int tkind, char *macroname);
static void startgraph(char *name, int directed, int strict);
static void bufferedges(void);
static void newedge(Agnode_t *t, char *tport, Agnode_t *h, char *hport, char *key);
static void edgerhs(Agnode_t *n, char *tport, item *hlist, char *key);
static void appendattr(char *name, char *value);
static void bindattrs(int kind);
static void applyattrs(void *obj);
static void endgraph(void);
static void endnode(void);
static void endedge(void);
static char* concat(char*, char*);

static void opensubg(char *name);
static void closesubg(void);

/* global */
static Agraph_t *G;


#line 66 "/home/ellson/graphviz/agraph/grammar.y"
#ifndef YYSTYPE
typedef union	{
			int				i;
			char			*str;
			struct Agnode_s	*n;
} ag_yystype;
# define YYSTYPE ag_yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		79
#define	YYFLAG		-32768
#define	YYNTBASE	24

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 267 ? ag_yytranslate[x] : 58)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char ag_yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    23,    17,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    18,    16,
       2,    19,     2,     2,    22,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    20,     2,    21,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    14,     2,    15,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13
};

#if YYDEBUG
static const short ag_yyprhs[] =
{
       0,     0,     3,     5,     6,    10,    14,    16,    17,    19,
      20,    22,    24,    26,    27,    30,    32,    34,    35,    38,
      41,    45,    47,    49,    50,    55,    56,    58,    62,    65,
      68,    69,    73,    75,    77,    79,    81,    84,    85,    87,
      88,    93,    95,    96,    98,   102,   104,   106,   110,   113,
     115,   116,   120,   123,   125,   126,   128,   130,   131,   133,
     135,   137
};
static const short ag_yyrhs[] =
{
      26,    25,     0,     1,     0,     0,    14,    30,    15,     0,
      28,    29,    27,     0,    56,     0,     0,     8,     0,     0,
       3,     0,     6,     0,    31,     0,     0,    31,    33,     0,
      33,     0,    16,     0,     0,    41,    32,     0,    34,    32,
       0,    35,    36,    44,     0,    38,     0,    52,     0,     0,
       9,    37,    35,    36,     0,     0,    39,     0,    38,    17,
      39,     0,    56,    40,     0,    18,    56,     0,     0,    42,
      43,    45,     0,    51,     0,     3,     0,     4,     0,     5,
       0,    56,    19,     0,     0,    45,     0,     0,    44,    20,
      46,    21,     0,    47,     0,     0,    48,     0,    47,    55,
      48,     0,    49,     0,    50,     0,    56,    19,    56,     0,
      22,    56,     0,    49,     0,     0,    54,    53,    25,     0,
       7,    56,     0,     7,     0,     0,    16,     0,    17,     0,
       0,    12,     0,    57,     0,    13,     0,    57,    23,    13,
       0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short ag_yyrline[] =
{
       0,    83,    84,    85,    88,    90,    93,    93,    95,    95,
      97,    97,    99,    99,   101,   101,   103,   103,   105,   106,
     109,   113,   113,   115,   115,   116,   120,   120,   122,   125,
     126,   129,   130,   133,   134,   135,   138,   139,   142,   142,
     144,   146,   146,   148,   149,   152,   152,   154,   157,   160,
     163,   163,   166,   167,   168,   171,   171,   171,   173,   174,
     177,   178
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const ag_yytname[] =
{
  "$", "error", "$undefined.", "T_graph", "T_node", "T_edge", "T_digraph", 
  "T_subgraph", "T_strict", "T_edgeop", "T_list", "T_attr", "T_atom", 
  "T_qatom", "'{'", "'}'", "';'", "','", "':'", "'='", "'['", "']'", 
  "'@'", "'+'", "graph", "body", "hdr", "optgraphname", "optstrict", 
  "graphtype", "optstmtlist", "stmtlist", "optsemi", "stmt", "compound", 
  "simple", "rcompound", "@1", "nodelist", "node", "optport", "attrstmt", 
  "attrtype", "optmacroname", "optattr", "attrlist", "optattrdefs", 
  "attrdefs", "attritem", "attrassignment", "attrmacro", "graphattrdefs", 
  "subgraph", "@2", "optsubghdr", "optseparator", "atom", "qatom", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short ag_yyr1[] =
{
       0,    24,    24,    24,    25,    26,    27,    27,    28,    28,
      29,    29,    30,    30,    31,    31,    32,    32,    33,    33,
      34,    35,    35,    37,    36,    36,    38,    38,    39,    40,
      40,    41,    41,    42,    42,    42,    43,    43,    44,    44,
      45,    46,    46,    47,    47,    48,    48,    49,    50,    51,
      53,    52,    54,    54,    54,    55,    55,    55,    56,    56,
      57,    57
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short ag_yyr2[] =
{
       0,     2,     1,     0,     3,     3,     1,     0,     1,     0,
       1,     1,     1,     0,     2,     1,     1,     0,     2,     2,
       3,     1,     1,     0,     4,     0,     1,     3,     2,     2,
       0,     3,     1,     1,     1,     1,     2,     0,     1,     0,
       4,     1,     0,     1,     3,     1,     1,     3,     2,     1,
       0,     3,     2,     1,     0,     1,     1,     0,     1,     1,
       1,     3
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short ag_yydefact[] =
{
       0,     2,     8,     0,     0,    13,     1,    10,    11,     7,
      33,    34,    35,    53,    58,    60,     0,    12,    15,    17,
      25,    21,    26,    17,    37,    49,    32,    22,    50,    30,
      59,     5,     6,    52,     4,    14,    16,    19,    23,    39,
       0,    18,    39,     0,     0,     0,     0,    28,     0,    54,
      20,    38,    27,    30,     0,    31,    36,    51,    29,    47,
      61,    25,    42,    24,     0,     0,    57,    43,    45,    46,
       0,    48,    40,    55,    56,     0,    44,     0,     0,     0
};

static const short ag_yydefgoto[] =
{
      77,     6,     3,    31,     4,     9,    16,    17,    37,    18,
      19,    20,    39,    49,    21,    22,    47,    23,    24,    42,
      50,    51,    65,    66,    67,    25,    69,    26,    27,    44,
      28,    75,    29,    30
};

static const short ag_yypact[] =
{
      19,-32768,-32768,    -1,    18,     4,-32768,-32768,-32768,    20,
  -32768,-32768,-32768,    20,-32768,-32768,    11,     4,-32768,    14,
      25,    21,-32768,    14,    20,-32768,-32768,-32768,-32768,    23,
      12,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
      20,-32768,-32768,    24,    -1,    20,    20,-32768,    26,    16,
      27,-32768,-32768,    28,    27,    29,-32768,-32768,-32768,-32768,
  -32768,    25,   -10,-32768,    20,    30,   -11,-32768,-32768,-32768,
      31,-32768,-32768,-32768,-32768,   -10,-32768,    44,    45,-32768
};

static const short ag_yypgoto[] =
{
  -32768,     8,-32768,-32768,-32768,-32768,-32768,-32768,    33,    37,
  -32768,     9,   -13,-32768,-32768,    17,-32768,-32768,-32768,-32768,
      22,    32,-32768,-32768,   -16,   -61,-32768,-32768,-32768,-32768,
  -32768,-32768,    -9,-32768
};


#define	YYLAST		74


static const short ag_yytable[] =
{
      32,    68,    14,    15,    33,    73,    74,    10,    11,    12,
     -41,    13,    64,     5,    68,    43,    14,    15,   -54,    -3,
       1,     7,    -9,    13,     8,    -9,    34,     2,    14,    15,
      36,    53,    14,    15,    38,    48,    58,    59,    40,    60,
      53,    45,    46,    56,    78,    79,    45,    62,    63,   -38,
      46,    72,    57,    70,    35,    71,    41,    52,    61,    76,
       0,     0,     0,     0,    54,     0,    70,     0,     0,     0,
       0,     0,     0,     0,    55
};

static const short ag_yycheck[] =
{
       9,    62,    12,    13,    13,    16,    17,     3,     4,     5,
      21,     7,    22,    14,    75,    24,    12,    13,    14,     0,
       1,     3,     3,     7,     6,     6,    15,     8,    12,    13,
      16,    40,    12,    13,     9,    23,    45,    46,    17,    13,
      49,    18,    19,    19,     0,     0,    18,    20,    61,    20,
      19,    21,    44,    62,    17,    64,    23,    40,    49,    75,
      -1,    -1,    -1,    -1,    42,    -1,    75,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    42
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with ag_yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (ag_yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (ag_yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (ag_yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union ag_yyalloc
{
  short ag_yyss;
  YYSTYPE ag_yyvs;
# if YYLSP_NEEDED
  YYLTYPE ag_yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union ag_yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T ag_yyi;		\
	  for (ag_yyi = 0; ag_yyi < (Count); ag_yyi++)	\
	    (To)[ag_yyi] = (From)[ag_yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T ag_yynewbytes;						\
	YYCOPY (&ag_yyptr->Stack, Stack, ag_yysize);				\
	Stack = &ag_yyptr->Stack;						\
	ag_yynewbytes = ag_yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	ag_yyptr += ag_yynewbytes / sizeof (*ag_yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define ag_yyerrok		(ag_yyerrstatus = 0)
#define ag_yyclearin	(ag_yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto ag_yyacceptlab
#define YYABORT 	goto ag_yyabortlab
#define YYERROR		goto ag_yyerrlab1
/* Like YYERROR except do call ag_yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto ag_yyerrlab
#define YYRECOVERING()  (!!ag_yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (ag_yychar == YYEMPTY && ag_yylen == 1)				\
    {								\
      ag_yychar = (Token);						\
      ag_yylval = (Value);						\
      ag_yychar1 = YYTRANSLATE (ag_yychar);				\
      YYPOPSTACK;						\
      goto ag_yybackup;						\
    }								\
  else								\
    { 								\
      ag_yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `ag_yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		ag_yylex (&ag_yylval, &ag_yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		ag_yylex (&ag_yylval, &ag_yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		ag_yylex (&ag_yylval, YYLEX_PARAM)
#  else
#   define YYLEX		ag_yylex (&ag_yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			ag_yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (ag_yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int ag_yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef ag_yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define ag_yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
ag_yystrlen (const char *ag_yystr)
#   else
ag_yystrlen (ag_yystr)
     const char *ag_yystr;
#   endif
{
  register const char *ag_yys = ag_yystr;

  while (*ag_yys++ != '\0')
    continue;

  return ag_yys - ag_yystr - 1;
}
#  endif
# endif

# ifndef ag_yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define ag_yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
ag_yystpcpy (char *ag_yydest, const char *ag_yysrc)
#   else
ag_yystpcpy (ag_yydest, ag_yysrc)
     char *ag_yydest;
     const char *ag_yysrc;
#   endif
{
  register char *ag_yyd = ag_yydest;
  register const char *ag_yys = ag_yysrc;

  while ((*ag_yyd++ = *ag_yys++) != '\0')
    continue;

  return ag_yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into ag_yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int ag_yyparse (void *);
# else
int ag_yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int ag_yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE ag_yylval;						\
							\
/* Number of parse errors so far.  */			\
int ag_yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE ag_yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
ag_yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int ag_yystate;
  register int ag_yyn;
  int ag_yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int ag_yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int ag_yychar1 = 0;

  /* Three stacks and their tools:
     `ag_yyss': related to states,
     `ag_yyvs': related to semantic values,
     `ag_yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow ag_yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	ag_yyssa[YYINITDEPTH];
  short *ag_yyss = ag_yyssa;
  register short *ag_yyssp;

  /* The semantic value stack.  */
  YYSTYPE ag_yyvsa[YYINITDEPTH];
  YYSTYPE *ag_yyvs = ag_yyvsa;
  register YYSTYPE *ag_yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE ag_yylsa[YYINITDEPTH];
  YYLTYPE *ag_yyls = ag_yylsa;
  YYLTYPE *ag_yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (ag_yyvsp--, ag_yyssp--, ag_yylsp--)
#else
# define YYPOPSTACK   (ag_yyvsp--, ag_yyssp--)
#endif

  YYSIZE_T ag_yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE ag_yyval;
#if YYLSP_NEEDED
  YYLTYPE ag_yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int ag_yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  ag_yystate = 0;
  ag_yyerrstatus = 0;
  ag_yynerrs = 0;
  ag_yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  ag_yyssp = ag_yyss;
  ag_yyvsp = ag_yyvs;
#if YYLSP_NEEDED
  ag_yylsp = ag_yyls;
#endif
  goto ag_yysetstate;

/*------------------------------------------------------------.
| ag_yynewstate -- Push a new state, which is found in ag_yystate.  |
`------------------------------------------------------------*/
 ag_yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  ag_yyssp++;

 ag_yysetstate:
  *ag_yyssp = ag_yystate;

  if (ag_yyssp >= ag_yyss + ag_yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T ag_yysize = ag_yyssp - ag_yyss + 1;

#ifdef ag_yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *ag_yyvs1 = ag_yyvs;
	short *ag_yyss1 = ag_yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *ag_yyls1 = ag_yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if ag_yyoverflow is a macro.  */
	ag_yyoverflow ("parser stack overflow",
		    &ag_yyss1, ag_yysize * sizeof (*ag_yyssp),
		    &ag_yyvs1, ag_yysize * sizeof (*ag_yyvsp),
		    &ag_yyls1, ag_yysize * sizeof (*ag_yylsp),
		    &ag_yystacksize);
	ag_yyls = ag_yyls1;
# else
	ag_yyoverflow ("parser stack overflow",
		    &ag_yyss1, ag_yysize * sizeof (*ag_yyssp),
		    &ag_yyvs1, ag_yysize * sizeof (*ag_yyvsp),
		    &ag_yystacksize);
# endif
	ag_yyss = ag_yyss1;
	ag_yyvs = ag_yyvs1;
      }
#else /* no ag_yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto ag_yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (ag_yystacksize >= YYMAXDEPTH)
	goto ag_yyoverflowlab;
      ag_yystacksize *= 2;
      if (ag_yystacksize > YYMAXDEPTH)
	ag_yystacksize = YYMAXDEPTH;

      {
	short *ag_yyss1 = ag_yyss;
	union ag_yyalloc *ag_yyptr =
	  (union ag_yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (ag_yystacksize));
	if (! ag_yyptr)
	  goto ag_yyoverflowlab;
	YYSTACK_RELOCATE (ag_yyss);
	YYSTACK_RELOCATE (ag_yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (ag_yyls);
# endif
# undef YYSTACK_RELOCATE
	if (ag_yyss1 != ag_yyssa)
	  YYSTACK_FREE (ag_yyss1);
      }
# endif
#endif /* no ag_yyoverflow */

      ag_yyssp = ag_yyss + ag_yysize - 1;
      ag_yyvsp = ag_yyvs + ag_yysize - 1;
#if YYLSP_NEEDED
      ag_yylsp = ag_yyls + ag_yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) ag_yystacksize));

      if (ag_yyssp >= ag_yyss + ag_yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", ag_yystate));

  goto ag_yybackup;


/*-----------.
| ag_yybackup.  |
`-----------*/
ag_yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* ag_yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  ag_yyn = ag_yypact[ag_yystate];
  if (ag_yyn == YYFLAG)
    goto ag_yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* ag_yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (ag_yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      ag_yychar = YYLEX;
    }

  /* Convert token to internal form (in ag_yychar1) for indexing tables with */

  if (ag_yychar <= 0)		/* This means end of input. */
    {
      ag_yychar1 = 0;
      ag_yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      ag_yychar1 = YYTRANSLATE (ag_yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (ag_yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     ag_yychar, ag_yytname[ag_yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, ag_yychar, ag_yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  ag_yyn += ag_yychar1;
  if (ag_yyn < 0 || ag_yyn > YYLAST || ag_yycheck[ag_yyn] != ag_yychar1)
    goto ag_yydefault;

  ag_yyn = ag_yytable[ag_yyn];

  /* ag_yyn is what to do for this token type in this state.
     Negative => reduce, -ag_yyn is rule number.
     Positive => shift, ag_yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (ag_yyn < 0)
    {
      if (ag_yyn == YYFLAG)
	goto ag_yyerrlab;
      ag_yyn = -ag_yyn;
      goto ag_yyreduce;
    }
  else if (ag_yyn == 0)
    goto ag_yyerrlab;

  if (ag_yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      ag_yychar, ag_yytname[ag_yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (ag_yychar != YYEOF)
    ag_yychar = YYEMPTY;

  *++ag_yyvsp = ag_yylval;
#if YYLSP_NEEDED
  *++ag_yylsp = ag_yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (ag_yyerrstatus)
    ag_yyerrstatus--;

  ag_yystate = ag_yyn;
  goto ag_yynewstate;


/*-----------------------------------------------------------.
| ag_yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
ag_yydefault:
  ag_yyn = ag_yydefact[ag_yystate];
  if (ag_yyn == 0)
    goto ag_yyerrlab;
  goto ag_yyreduce;


/*-----------------------------.
| ag_yyreduce -- Do a reduction.  |
`-----------------------------*/
ag_yyreduce:
  /* ag_yyn is the number of a rule to reduce with.  */
  ag_yylen = ag_yyr2[ag_yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  ag_yyval = ag_yyvsp[1-ag_yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  ag_yyloc = ag_yylsp[1-ag_yylen];
  YYLLOC_DEFAULT (ag_yyloc, (ag_yylsp - ag_yylen), ag_yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (ag_yydebug)
    {
      int ag_yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 ag_yyn, ag_yyrline[ag_yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (ag_yyi = ag_yyprhs[ag_yyn]; ag_yyrhs[ag_yyi] > 0; ag_yyi++)
	YYFPRINTF (stderr, "%s ", ag_yytname[ag_yyrhs[ag_yyi]]);
      YYFPRINTF (stderr, " -> %s\n", ag_yytname[ag_yyr1[ag_yyn]]);
    }
#endif

  switch (ag_yyn) {

case 1:
#line 83 "/home/ellson/graphviz/agraph/grammar.y"
{endgraph();}
    break;
case 2:
#line 84 "/home/ellson/graphviz/agraph/grammar.y"
{if (G) {agclose(G); G = Ag_G_global = NIL(Agraph_t*);}}
    break;
case 5:
#line 90 "/home/ellson/graphviz/agraph/grammar.y"
{startgraph(ag_yyvsp[0].str,ag_yyvsp[-1].i,ag_yyvsp[-2].i);}
    break;
case 6:
#line 93 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.str=ag_yyvsp[0].str;}
    break;
case 7:
#line 93 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.str=0;}
    break;
case 8:
#line 95 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.i=1;}
    break;
case 9:
#line 95 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.i=0;}
    break;
case 10:
#line 97 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.i = 0;}
    break;
case 11:
#line 97 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.i = 1;}
    break;
case 20:
#line 110 "/home/ellson/graphviz/agraph/grammar.y"
{if (ag_yyvsp[-1].i) endedge(); else endnode();}
    break;
case 23:
#line 115 "/home/ellson/graphviz/agraph/grammar.y"
{bufferedges();}
    break;
case 24:
#line 115 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.i = 1;}
    break;
case 25:
#line 116 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.i = 0;}
    break;
case 28:
#line 122 "/home/ellson/graphviz/agraph/grammar.y"
{appendnode(ag_yyvsp[-1].str,ag_yyvsp[0].str);}
    break;
case 29:
#line 125 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.str = ag_yyvsp[0].str;}
    break;
case 30:
#line 126 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.str = NIL(char*);}
    break;
case 31:
#line 129 "/home/ellson/graphviz/agraph/grammar.y"
{attrstmt(ag_yyvsp[-2].i,ag_yyvsp[-1].str);}
    break;
case 32:
#line 130 "/home/ellson/graphviz/agraph/grammar.y"
{attrstmt(T_graph,NIL(char*));}
    break;
case 33:
#line 133 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.i = T_graph;}
    break;
case 34:
#line 134 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.i = T_node;}
    break;
case 35:
#line 135 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.i = T_edge;}
    break;
case 36:
#line 138 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.str = ag_yyvsp[-1].str;}
    break;
case 37:
#line 139 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.str = NIL(char*); }
    break;
case 47:
#line 154 "/home/ellson/graphviz/agraph/grammar.y"
{appendattr(ag_yyvsp[-2].str,ag_yyvsp[0].str);}
    break;
case 48:
#line 157 "/home/ellson/graphviz/agraph/grammar.y"
{appendattr(ag_yyvsp[0].str,NIL(char*));}
    break;
case 50:
#line 163 "/home/ellson/graphviz/agraph/grammar.y"
{opensubg(ag_yyvsp[0].str);}
    break;
case 51:
#line 163 "/home/ellson/graphviz/agraph/grammar.y"
{closesubg();}
    break;
case 52:
#line 166 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.str=ag_yyvsp[0].str;}
    break;
case 53:
#line 167 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.str=NIL(char*);}
    break;
case 54:
#line 168 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.str=NIL(char*);}
    break;
case 58:
#line 173 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.str = ag_yyvsp[0].str;}
    break;
case 59:
#line 174 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.str = ag_yyvsp[0].str;}
    break;
case 60:
#line 177 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.str = ag_yyvsp[0].str;}
    break;
case 61:
#line 179 "/home/ellson/graphviz/agraph/grammar.y"
{ag_yyval.str = concat(ag_yyvsp[-2].str,ag_yyvsp[0].str); agstrfree(G,ag_yyvsp[-2].str); agstrfree(G,ag_yyvsp[0].str);}
    break;
}

#line 705 "/usr/share/bison/bison.simple"


  ag_yyvsp -= ag_yylen;
  ag_yyssp -= ag_yylen;
#if YYLSP_NEEDED
  ag_yylsp -= ag_yylen;
#endif

#if YYDEBUG
  if (ag_yydebug)
    {
      short *ag_yyssp1 = ag_yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (ag_yyssp1 != ag_yyssp)
	YYFPRINTF (stderr, " %d", *++ag_yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++ag_yyvsp = ag_yyval;
#if YYLSP_NEEDED
  *++ag_yylsp = ag_yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  ag_yyn = ag_yyr1[ag_yyn];

  ag_yystate = ag_yypgoto[ag_yyn - YYNTBASE] + *ag_yyssp;
  if (ag_yystate >= 0 && ag_yystate <= YYLAST && ag_yycheck[ag_yystate] == *ag_yyssp)
    ag_yystate = ag_yytable[ag_yystate];
  else
    ag_yystate = ag_yydefgoto[ag_yyn - YYNTBASE];

  goto ag_yynewstate;


/*------------------------------------.
| ag_yyerrlab -- here on detecting error |
`------------------------------------*/
ag_yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!ag_yyerrstatus)
    {
      ++ag_yynerrs;

#ifdef YYERROR_VERBOSE
      ag_yyn = ag_yypact[ag_yystate];

      if (ag_yyn > YYFLAG && ag_yyn < YYLAST)
	{
	  YYSIZE_T ag_yysize = 0;
	  char *ag_yymsg;
	  int ag_yyx, ag_yycount;

	  ag_yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (ag_yyx = ag_yyn < 0 ? -ag_yyn : 0;
	       ag_yyx < (int) (sizeof (ag_yytname) / sizeof (char *)); ag_yyx++)
	    if (ag_yycheck[ag_yyx + ag_yyn] == ag_yyx)
	      ag_yysize += ag_yystrlen (ag_yytname[ag_yyx]) + 15, ag_yycount++;
	  ag_yysize += ag_yystrlen ("parse error, unexpected ") + 1;
	  ag_yysize += ag_yystrlen (ag_yytname[YYTRANSLATE (ag_yychar)]);
	  ag_yymsg = (char *) YYSTACK_ALLOC (ag_yysize);
	  if (ag_yymsg != 0)
	    {
	      char *ag_yyp = ag_yystpcpy (ag_yymsg, "parse error, unexpected ");
	      ag_yyp = ag_yystpcpy (ag_yyp, ag_yytname[YYTRANSLATE (ag_yychar)]);

	      if (ag_yycount < 5)
		{
		  ag_yycount = 0;
		  for (ag_yyx = ag_yyn < 0 ? -ag_yyn : 0;
		       ag_yyx < (int) (sizeof (ag_yytname) / sizeof (char *));
		       ag_yyx++)
		    if (ag_yycheck[ag_yyx + ag_yyn] == ag_yyx)
		      {
			const char *ag_yyq = ! ag_yycount ? ", expecting " : " or ";
			ag_yyp = ag_yystpcpy (ag_yyp, ag_yyq);
			ag_yyp = ag_yystpcpy (ag_yyp, ag_yytname[ag_yyx]);
			ag_yycount++;
		      }
		}
	      ag_yyerror (ag_yymsg);
	      YYSTACK_FREE (ag_yymsg);
	    }
	  else
	    ag_yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	ag_yyerror ("parse error");
    }
  goto ag_yyerrlab1;


/*--------------------------------------------------.
| ag_yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
ag_yyerrlab1:
  if (ag_yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (ag_yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  ag_yychar, ag_yytname[ag_yychar1]));
      ag_yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  ag_yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto ag_yyerrhandle;


/*-------------------------------------------------------------------.
| ag_yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
ag_yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  ag_yyn = ag_yydefact[ag_yystate];
  if (ag_yyn)
    goto ag_yydefault;
#endif


/*---------------------------------------------------------------.
| ag_yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
ag_yyerrpop:
  if (ag_yyssp == ag_yyss)
    YYABORT;
  ag_yyvsp--;
  ag_yystate = *--ag_yyssp;
#if YYLSP_NEEDED
  ag_yylsp--;
#endif

#if YYDEBUG
  if (ag_yydebug)
    {
      short *ag_yyssp1 = ag_yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (ag_yyssp1 != ag_yyssp)
	YYFPRINTF (stderr, " %d", *++ag_yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| ag_yyerrhandle.  |
`--------------*/
ag_yyerrhandle:
  ag_yyn = ag_yypact[ag_yystate];
  if (ag_yyn == YYFLAG)
    goto ag_yyerrdefault;

  ag_yyn += YYTERROR;
  if (ag_yyn < 0 || ag_yyn > YYLAST || ag_yycheck[ag_yyn] != YYTERROR)
    goto ag_yyerrdefault;

  ag_yyn = ag_yytable[ag_yyn];
  if (ag_yyn < 0)
    {
      if (ag_yyn == YYFLAG)
	goto ag_yyerrpop;
      ag_yyn = -ag_yyn;
      goto ag_yyreduce;
    }
  else if (ag_yyn == 0)
    goto ag_yyerrpop;

  if (ag_yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++ag_yyvsp = ag_yylval;
#if YYLSP_NEEDED
  *++ag_yylsp = ag_yylloc;
#endif

  ag_yystate = ag_yyn;
  goto ag_yynewstate;


/*-------------------------------------.
| ag_yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
ag_yyacceptlab:
  ag_yyresult = 0;
  goto ag_yyreturn;

/*-----------------------------------.
| ag_yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
ag_yyabortlab:
  ag_yyresult = 1;
  goto ag_yyreturn;

/*---------------------------------------------.
| ag_yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
ag_yyoverflowlab:
  ag_yyerror ("parser stack overflow");
  ag_yyresult = 2;
  /* Fall through.  */

ag_yyreturn:
#ifndef ag_yyoverflow
  if (ag_yyss != ag_yyssa)
    YYSTACK_FREE (ag_yyss);
#endif
  return ag_yyresult;
}
#line 181 "/home/ellson/graphviz/agraph/grammar.y"


#define NILitem  NIL(item*)

/* globals */
static	Agraph_t	*Subgraph;	/* most recent subgraph that was opened */
static	Agdisc_t	*Disc;		/* discipline passed to agread or agconcat */
static	list_t	Nodelist,Edgelist,Attrlist;

static item *newitem(int tag, void *p0, char *p1)
{
	item	*rv = agalloc(G,sizeof(item));
	rv->tag = tag; rv->u.name = (char*)p0; rv->str = p1;
	return rv;
}

static item *cons_node(Agnode_t *n, char *port)
	{ return newitem(T_node,n,port); }

static item *cons_attr(char *name, char *value)
	{ return newitem(T_atom,name,value); }

static item *cons_list(item *list)
	{ return newitem(T_list,list,NIL(char*)); }

static item *cons_subg(Agraph_t *subg)
	{ return newitem(T_subgraph,subg,NIL(char*)); }

#ifdef NOTDEF
static item *cons_edge(Agedge_t *e)
	{ return newitem(T_edge,e,NIL(char*)); }
#endif

static void delete_items(item *ilist)
{
	item	*p,*pn;

	for (p = ilist; p; p = pn) {
		pn = p->next;
		switch(p->tag) {
			case T_list: delete_items(p->u.list); break;
			case T_atom: case T_attr: agstrfree(G,p->str); break;
		}
		agfree(G,p);
	}
}

static void deletelist(list_t *list)
{
	delete_items(list->first);
	list->first = list->last = NILitem;
}

#ifdef NOTDEF
static void listins(list_t *list, item *v)
{
	v->next = list->first;
	list->first = v;
	if (list->last == NILitem) list->last = v;
}
#endif

static void listapp(list_t *list, item *v)
{
	if (list->last) list->last->next = v;
	list->last = v;
	if (list->first == NILitem) list->first = v;
}


/* attrs */
static void appendattr(char *name, char *value)
{
	item		*v;

	assert(value != NIL(char*));
	v = cons_attr(name,value);
	listapp(&Attrlist,v);
}

static void bindattrs(int kind)
{
	item		*aptr;
	char		*name;

	for (aptr = Attrlist.first; aptr; aptr = aptr->next) {
		assert(aptr->tag == T_atom);	/* signifies unbound attr */
		name = aptr->u.name;
		if ((kind == AGEDGE) && streq(name,Key)) continue;
		if ((aptr->u.asym = agattr(G,kind,name,NIL(char*))) == NILsym)
			aptr->u.asym = agattr(G,kind,name,"");
		aptr->tag = T_attr;				/* signifies bound attr */
		agstrfree(G,name);
	}
}

static void applyattrs(void *obj)
{
	item		*aptr;

	for (aptr = Attrlist.first; aptr; aptr = aptr->next) {
		if (aptr->tag == T_attr) {
			if (aptr->u.asym) {
				agxset(obj,aptr->u.asym,aptr->str);
			}
		}
		else {
			assert(AGTYPE(obj) == AGEDGE);
			assert(aptr->tag == T_atom);
			assert(streq(aptr->u.name,Key));
		}
	}
}

static void nomacros(void)
{
	agerror(AGERROR_UNIMPL,"attribute macros");
}

static void attrstmt(int tkind, char *macroname)
{
	item			*aptr;
	int				kind;

		/* creating a macro def */
	if (macroname) nomacros();
		/* invoking a macro def */
	for (aptr = Attrlist.first; aptr; aptr = aptr->next)
		if (aptr->str == NIL(char*)) nomacros();

	switch(tkind) {
		case T_graph: kind = AGRAPH; break;
		case T_node: kind = AGNODE; break;
		case T_edge: kind = AGEDGE; break;
		default : abort();
	}
	bindattrs(kind);	/* set up defaults for new attributes */
	for (aptr = Attrlist.first; aptr; aptr = aptr->next)
		agattr(G,kind,aptr->u.asym->name,aptr->str);
	deletelist(&Attrlist);
}

/* nodes */

static void appendnode(char *name, char *port)
{
	item		*elt;

	elt = cons_node(agnode(G,name,TRUE),port);
	listapp(&Nodelist,elt);
	agstrfree(G,name);
}

	/* apply current optional attrs to Nodelist and clean up lists */
static void endnode()
{
	item	*ptr;

	bindattrs(AGNODE);
	for (ptr = Nodelist.first; ptr; ptr = ptr->next)
		applyattrs(ptr->u.n);
	deletelist(&Nodelist);
	deletelist(&Attrlist);
}

/* edges - store up node/subg lists until optional edge key can be seen */

static void bufferedges()
{
	item	*v;

	if (Nodelist.first) {
		v = cons_list(Nodelist.first);
		Nodelist.first = Nodelist.last = NILitem;
	}
	else {v = cons_subg(Subgraph); Subgraph = NIL(Agraph_t*);}
	listapp(&Edgelist,v);
}

static void endedge(void)
{
	char			*key;
	item			*aptr,*tptr,*p;

	Agnode_t		*t;
	Agraph_t		*subg;

	bufferedges();	/* pick up the terminal nodelist or subg */
	bindattrs(AGEDGE);

	/* look for "key" pseudo-attribute */
	key = NIL(char*);
	for (aptr = Attrlist.first; aptr; aptr = aptr->next) {
		if ((aptr->tag == T_atom) && streq(aptr->u.name,Key))
			key = aptr->str;
	}

	/* can make edges with node lists or subgraphs */
	for (p = Edgelist.first; p->next; p = p->next) {
		if (p->tag == T_subgraph) {
			subg = p->u.subg;
			for (t = agfstnode(subg); t; t = agnxtnode(t))
				edgerhs(agsubnode(G,t,FALSE),NIL(char*),p->next,key);
		}
		else {
			for (tptr = p->u.list; tptr; tptr = tptr->next)
				edgerhs(tptr->u.n,tptr->str,p->next,key);
		}
	}
	deletelist(&Edgelist);
	deletelist(&Attrlist);
}

/* concat:
 */
static char*
concat (char* s1, char* s2)
{
  char*  s;
  char   buf[BUFSIZ];
  char*  sym;
  int    len = strlen(s1) + strlen(s2) + 1;

  if (len <= BUFSIZ) sym = buf;
  else sym = (char*)malloc(len);
  strcpy(sym,s1);
  strcat(sym,s2);
  s = agstrdup (G,sym);
  agstrfree (G,s1);
  agstrfree (G,s2);
  if (sym != buf) free (sym);
  return s;
}


static void edgerhs(Agnode_t *tail, char *tport, item *hlist, char *key)
{
	Agnode_t		*head;
	Agraph_t		*subg;
	item			*hptr;

	if (hlist->tag == T_subgraph) {
		subg = hlist->u.subg;
		for (head = agfstnode(subg); head; head = agnxtnode(head))
			newedge(tail,tport,agsubnode(G,head,FALSE),NIL(char*),key);
	}
	else {
		for (hptr = hlist->u.list; hptr; hptr = hptr->next)
			newedge(tail,tport,agsubnode(G,hptr->u.n,FALSE),hptr->str,key);
	}
}

static void mkport(Agedge_t *e, char *name, char *val)
{
	Agsym_t *attr;
	if (val) {
		if ((attr = agattr(G,AGEDGE,name,NIL(char*))) == NILsym)
			attr = agattr(G,AGEDGE,name,"");
		agxset(e,attr,val);
	}
}

static void newedge(Agnode_t *t, char *tport, Agnode_t *h, char *hport, char *key)
{
	Agedge_t 	*e;

	e = agedge(t,h,key,TRUE);
	if (e) {		/* can fail if graph is strict and t==h */
		char    *tp = tport;
		char    *hp = hport;
		if ((agtail(e) != aghead(e)) && (aghead(e) == t)) {
			/* could happen with an undirected edge */
			char    *temp;
			temp = tp; tp = hp; hp = temp;
		}
		mkport(e,"tailport",tp);
		mkport(e,"headport",hp);
		applyattrs(e);
	}
}

/* graphs and subgraphs */


static void startgraph(char *name, int directed, int strict)
{
	static Agdesc_t	req;	/* get rid of warnings */

	if (G == NILgraph) {
		req.directed = directed;
		req.strict = strict;
		req.flatlock = FALSE;
		req.maingraph = TRUE;
		Ag_G_global = G = agopen(name,req,Disc);
	}
	else {
		Ag_G_global = G;
	}
	agstrfree(NIL(Agraph_t*),name);
}

static void endgraph()
{
	aglexeof();
	aginternalmapclearlocalnames(G);
}

static void opensubg(char *name)
{
	G = agsubg(G,name,TRUE);
	agstrfree(G,name);
}

static void closesubg()
{
	Subgraph = G;
	if ((G = agparent(G)) == NIL(Agraph_t*))
		ag_yyerror("libgraph: parser lost root graph\n");
}

extern void *ag_yyin;
Agraph_t *agconcat(Agraph_t *g, void *chan, Agdisc_t *disc)
{
	ag_yyin = chan;
	G = g;
	Ag_G_global = NILgraph;
	Disc = (disc? disc :  &AgDefaultDisc);
	aglexinit(Disc, chan);
	ag_yyparse();
	return Ag_G_global;
}

Agraph_t *agread(void *fp, Agdisc_t *disc) {return agconcat(NILgraph,fp,disc); }
